#include <iostream>
#include <list>
#include <algorithm>
#include <functional>
#include "PRINT.h"
using namespace std;

bool jedesDritte (int elem)
{
    static int anzahl = 0;

    anzahl++;
    if (anzahl == 3) {
        anzahl = 0;
        return true;
    }
    else {
        return false;
    }
}

int main()
{
    list<int> menge;

    /* Elemente 6 bis 1 und 1 bis 6 in die Menge einfuegen
     */
    for (int i=1; i<=6; i++) {
        menge.push_front(i);    // vorne absteigend
        menge.push_back(i);     // hinten aufsteigend
    }

    PRINT ("menge:    ", menge);

    /* Elemente mit dem Wert 3 durch den Wert 7 ersetzen
     */
    replace (menge.begin(), menge.end(),
             3, 7);

    PRINT ("3 => 7:   ", menge);

    /* Elemente mit einem Wert groesser 4 durch den Wert 8 ersetzen
     */
    replace_if (menge.begin(), menge.end(),
                bind2nd(greater<int>(),4), 8);

    PRINT (">4 => 8:  ", menge);
    
    /* jedes dritte Element durch 0 ersetzen
     */
    replace_if (menge.begin(), menge.end(),
                jedesDritte, 0);

    PRINT ("3. => 0:  ", menge);
}
