#include <iostream>
#include <algorithm>
using namespace std;

int main()
{
    int m1[] = { 1, 2, 2, 4, 6, 7, 7, 9 };
    int anz1 = sizeof(m1) / sizeof(int);

    int m2[] = { 2, 2, 2, 3, 6, 6, 8, 9 };
    int anz2 = sizeof(m2) / sizeof(int);

    /* Teilmengen ausgeben
     */
    cout << "m1:                         " ;
    copy (m1, m1+anz1, ostream_iterator<int>(cout," "));
    cout << endl;
    cout << "m2:                         " ;
    copy (m2, m2+anz2, ostream_iterator<int>(cout," "));
    cout << '\n' << endl;

    /* Gesamtmenge mit merge()
     */
    cout << "merge():                    ";
    merge (m1, m1+anz1, m2, m2+anz2,
           ostream_iterator<int>(cout," "));
    cout << endl;

    /* Vereinigungsmenge mit set_union()
     */
    cout << "set_union():                ";
    set_union (m1, m1+anz1, m2, m2+anz2,
               ostream_iterator<int>(cout," "));
    cout << endl;

    /* Schnittmenge mit set_intersection()
     */
    cout << "set_intersection():         ";
    set_intersection (m1, m1+anz1, m2, m2+anz2,
                      ostream_iterator<int>(cout," "));
    cout << endl;

    /* Differenzmenge m1 - m2 mit set_difference()
     */
    cout << "set_difference():           ";
    set_difference (m1, m1+anz1, m2, m2+anz2,
                      ostream_iterator<int>(cout," "));
    cout << endl;

    /* Unterschiedsmenge mit set_symmetric_difference()
     */
    cout << "set_symmetric_difference(): ";
    set_symmetric_difference (m1, m1+anz1, m2, m2+anz2,
                              ostream_iterator<int>(cout," "));
    cout << endl;

}
