// Header-Datei fuer Datei-I/O
#include <fstream>
using namespace std;

/* Alle als Parameter uebergebenen Dateien
 * nacheinander oeffnen, ausgeben und schliessen
 */
int main (int argc, char* argv[])
{
    ifstream datei;
    char c;

    // fuer alle Argumente aus der Kommandozeile
    for (int i=1; i<argc; i++) {

        // Datei oeffnen
        datei.open (argv[i]);

        // Inhalt ausgeben
        while (datei.get(c)) {
            cout.put(c);
        }

        // EOF/FAIL-Bit loeschen
        datei.clear();

        // Datei schliessen
        datei.close();
    }
}
