#include <iostream>
#include <vector>
#include <list>
#include <algorithm>
#include "PRINT.h"
using namespace std;

bool beideGeradeOderUngerade (int elem1, int elem2)
{
    return elem1 % 2 == elem2 % 2;
}

int main()
{
    vector<int> menge1;
    list<int> menge2;

    /* Elemente 1 bis 7 vorwaerts und rueckwaerts in die Mengen einfuegen
     */
    for (int i=1; i<=7; i++) {
        menge1.push_back(i);
        menge2.push_front(i);
    }

    PRINT ("menge1: ", menge1);
    PRINT ("menge2: ", menge2);

    /* beide Mengen gleich ?
     */
    if (equal (menge1.begin(), menge1.end(), menge2.begin())) {
        cout << "menge1 == menge2" << endl;
    }
    else {
        cout << "menge1 != menge2" << endl;
    }

    /* gerade und ungerade Elemente an den gleichen Stellen ?
     */
    if (equal (menge1.begin(), menge1.end(), menge2.begin(),
               beideGeradeOderUngerade)) {
        cout << "gerade und ungerade Elemente korrespondieren" << endl;
    }
    else {
        cout << "gerade und ungerade Elemente korrespondieren nicht"
             << endl;
    }
}
