#include <iostream>
#include <vector>
#include <algorithm>
#include "PRINT.h"
using namespace std;

int main()
{
    vector<int> menge;

    /* Elemente 1 bis 3 in die Menge einfuegen
     */
    for (int i=1; i<=3; i++) {
        menge.push_back(i);
    }

    PRINT ("vorher:  ", menge);

    /* Menge bis zur Sortierung permutieren
     *  - da am Anfang sortiert: ueber alle Varianten
     */
    while (next_permutation(menge.begin(), menge.end())) {
        PRINT (" ", menge);
    }

    PRINT ("nachher: ", menge);

    /* Menge bis zur umgekehrten Sortierung umgekehrt permutieren
     *  - da die Menge sortiert ist, ist das ein Aufruf
     *    (die Schleifen-Anweisung PRINT() wird also nie aufgerufen
     */
    while (prev_permutation(menge.begin(), menge.end())) {
        PRINT (" ", menge);
    }

    PRINT ("nun:     ", menge);

    /* Menge bis zur umgekehrten Sortierung permutieren
     *  - da umgekehrt sortiert: umgekehrt ueber alle Varianten
     */
    while (prev_permutation(menge.begin(), menge.end())) {
        PRINT (" ", menge);
    }

    PRINT ("nachher: ", menge);
}
